# Підтримка Документів Google для NVDA

Цей додаток поліпшує сумісність з Документами Google. Цей додаток працює в режимі огляду, забезпечуючи належну роботу команд швидкої навігації й команд навігації за допомогою курсорних клавіш. Наприклад, якщо ви використовуєте Документи Google без цього додатка, то натискання `H` призведе до переходу до наступного заголовка, але тільки серед тих, які видно на екрані. Цей додаток виправляє цю поведінку, і тепер команда `H` переноситиме вас до всіх заголовків у документі.

## Встановлення

Для коректної роботи цього додатка, вам потрібно увімкнути режим зчитування з екрана та режим підтримки дисплея Брайля. Для цього:
* Переконайтеся, що ваша стандартна комбінація клавіш на запуск NVDA або не призначена, або призначена на щось інше, а не на `Control+Alt+N`. Для цього відредагуйте властивості вашого ярлика NVDA на робочому столі. Ця вимога походить від Документів Google.
* Відкрийте будь-який документ Google.
* Натисніть `Control+Alt+Z`, допоки не почуєте повідомлення «Підтримку програм зчитування з екрана увімкнено».
* Натисніть `Control+Alt+H`, допоки не почуєте «Підтримку дисплея Брайля увімкнено».
* Натисніть `NVDA+пробіл`, щоб увійти в режим огляду, якщо ви перебуваєте в режимі фокуса.

## Вимоги

Підтримуються браузери:

* Google Chrome
* Mozilla Firefox

Наразі цей додаток вимагає, щоб на вашому комп'ютері була встановлена розкладка клавіатури «en_us». Це обов’язково, оскільки додаток має розпізнавати натискання клавіш у Документах Google, і він робить це у локалі «en_us». Якщо локаль «en_us» не буде знайдено, він аварійно завершить роботу. Будь ласка, надсилайте запити з виправленням цієї поведінки.

## Підтримувані команди

Загальні команди:

* `NVDA+Alt+G` — перемикає доступність Документів Google (дозволяє тимчасово вимкнути функціонал цього додатка)

Команди швидкої навігації (їхні аналоги `Shift+` опущені для стислості):

* `H` — наступний заголовок
* `1..6` — наступний заголовок рівня від 1 до 6
* `K` — наступне посилання
* `L` — наступний список
* `I` — наступний елемент списку
* `G` — наступна графіка
* `T` — наступна таблиця

Навігаційні команди:

* `стрілки`
* `Control+стрілки`
* `на початок`, `в кінець`
* `Control+на початок`, `Control+в кінець`
` сторінка вгору`, `сторінка вниз`

## Відомі проблеми

* Для роботи цього додатка на комп’ютері має бути встановлено розкладку клавіатури `en_us`.
* Цей додаток перетворює команди NVDA на жести Документів Google. Тому їхню поведінку не можна налаштувати.
    * Наприклад, багаторазове натискання `H` призведе до перенесення на початок документа. Це незручно для користувачів NVDA, але це стандартне налаштування у Документах Google і, на жаль, його не можна змінити.
* Команди виділення, такі як `Shift+Стрілки` наразі не підтримуються. Будь ласка, для виділення перемкніться в режим фокуса.
